unit IcmpUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    IcmpInfo: TMemo;
    Panel1: TPanel;
    btnClose: TButton;
    Panel2: TPanel;
    btnEcho: TButton;
    edIpAddr: TEdit;
    procedure btnEchoClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
  private
    { Private declarations }
    FIcmpHandle : THandle;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Uses
  IcmpApi,
  WinSock;  // For inet_addr (converts a XXX.XXX.XXX.XXX style IP address
            // int a binary address... remember first digits is last binary!)

Const
  IcmpData = 3200;
  IcmpMsg  = 'Ping %s with %d bytes -> round trip = %d';
  IcmpTime = 'Ping %s with %d bytes -> round trip TIMEOUT';
  IcmpErr  = 'Last error: %d';


procedure TForm1.btnEchoClick(Sender: TObject);
Var
  RequestOptions : TIPOptionInformation;
  Echo : PChar;
  Data : ARRAY[0..IcmpData-1] of Char;
  TempIp : LongInt;
  EchoSize,
  Return : Integer;
begin
  TempIp := inet_addr(PChar(edIpAddr.text));
  FIcmpHandle := IcmpCreateFile;
  If FIcmpHandle = 0 Then
  Begin
    IcmpInfo.Lines.Insert(0,Format(IcmpErr,[GetLastError]));
    Exit;
  end;
  FillChar(RequestOptions,SizeOf(TIPOptionInformation),#0);
  EchoSize := (SizeOf(TIcmpEchoReply)+IcmpData);
  Echo := StrAlloc(EchoSize+1);
  FillChar(Echo^,EchoSize+1,#0);


  Return := IcmpSendEcho(FIcmpHandle,
                         TempIp,
                         @Data,
                         IcmpData,
                         NIL,
                         Echo,
                         EchoSize,
                         100);
  If Return = 0 Then
  begin
    If GetLastError = IP_REQ_TIMED_OUT Then
      IcmpInfo.Lines.Insert(0,
         Format(IcmpTime,
                [edIpAddr.Text,
                 IcmpData]))
      else
        IcmpInfo.Lines.Insert(0,Format(IcmpErr,[GetLastError]));
  end
  else
    IcmpInfo.Lines.Insert(0,
       Format(IcmpMsg,
              [edIpAddr.Text,
               IcmpData,
               TIcmpEchoReply(Pointer(Echo)^).RoundTripTime]));
  StrDispose(Echo);
  IcmpCloseHandle(FIcmpHandle);
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Panel2Resize(Sender: TObject);
begin
  btnEcho.Left := Panel2.Width - btnEcho.Width - 2;
  edIpAddr.Width := Panel2.Width - btnEcho.Width - 6;
end;

end.
